#if !defined(AFX_SCICTRL_H__23720648_3734_11D5_9469_A8CCCCD6F97D__INCLUDED_)
#define AFX_SCICTRL_H__23720648_3734_11D5_9469_A8CCCCD6F97D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SciCtrl.h : header file
//


#define docsource doc[1].docptr
#define docoutput doc[2].docptr
#define doctlb doc[3].docptr
#define doclua doc[4].docptr


#define SCLEX_CONTAINER 0
#define SCLEX_NULL 1
#define SCLEX_PYTHON 2
#define SCLEX_CPP 3
#define SCLEX_HTML 4
#define SCLEX_XML 5
#define SCLEX_PERL 6
#define SCLEX_SQL 7
#define SCLEX_VB 8
#define SCLEX_PROPERTIES 9
#define SCLEX_ERRORLIST 10
#define SCLEX_MAKEFILE 11
#define SCLEX_BATCH 12
#define SCLEX_XCODE 13
#define SCLEX_LATEX 14
#define SCLEX_LUA 15
#define SCLEX_DIFF 16
#define SCLEX_CONF 17
#define SCLEX_PASCAL 18
#define SCLEX_AVE 19



static char * snamelist="CharLeft,CreateDocument,SetLexer,StyleSetFore,StyleSetBold,SetIndentationGuides,\
SetTabWidth,SetIndent,SetCaretPeriod,SetKeyWords,ReleaseDocument,\
ClearAll,AddText,MacroRecord,CharAdded,Modified,\
GetCurrentPos,GetCharAt,CallTipShow,AutoCShow,GetSelText,\
GetSelectionStart,GetSelectionEnd,SetSelectionStart,SetSelectionEnd,GetCurLine,\
LineFromPosition,LineLength,GetText,SetText,GetLine,\
GetLength,ScrollCaret,SetDocPointer,SetCaretLineBack,SetCaretLineVisible,\
SetLineState,GetLineState,GotoLine,MarkerDefine,MarkerAdd,\
MarkerDelete,MarkerGet,MarkerSetBack,CharRight,\
LineUp,LineDown,CallTipCancel,CallTipSetBack,CallTipSetHlt,\
GotoPos,CanUndo,CanRedo,GetAnchor,CanPaste,\
ReplaceSel,AutoCActive,AutoCCancel,AutoCSetCancelAtStart,UsePopUp,\
Undo,Redo,Cut,Copy,Paste,\
Clear,SelectAll,EmptyUndoBuffer,SearchAnchor,SearchNext,\
StartRecord,StopRecord,AutoCSetIgnoreCase";


	#define SCI_CHARLEFT m_ScintillaCommands[0]
	#define SCI_CREATEDOCUMENT m_ScintillaCommands[1]
	#define SCI_SETLEXER m_ScintillaCommands[2]
	#define SCI_STYLESETFORE m_ScintillaCommands[3]
	#define SCI_STYLESETBOLD m_ScintillaCommands[4]
	#define SCI_SETINDENTATIONGUIDES  m_ScintillaCommands[5]
	#define SCI_SETTABWIDTH m_ScintillaCommands[6]
	#define SCI_SETINDENT m_ScintillaCommands[7]
	#define SCI_SETCARETPERIOD m_ScintillaCommands[8]
	#define SCI_SETKEYWORDS m_ScintillaCommands[9]
	#define SCI_RELEASEDOCUMENT m_ScintillaCommands[10]
	#define SCI_CLEARALL m_ScintillaCommands[11]
	#define SCI_ADDTEXT m_ScintillaCommands[12]
	#define SCN_MACRORECORD m_ScintillaCommands[13]
	#define SCN_CHARADDED m_ScintillaCommands[14]
	#define SCN_MODIFIED m_ScintillaCommands[15]
	#define SCI_GETCURRENTPOS m_ScintillaCommands[16]
	#define SCI_GETCHARAT m_ScintillaCommands[17]
	#define SCI_CALLTIPSHOW m_ScintillaCommands[18]
	#define SCI_AUTOCSHOW m_ScintillaCommands[19]
	#define SCI_GETSELTEXT m_ScintillaCommands[20]
	#define SCI_GETSELECTIONSTART m_ScintillaCommands[21]
	#define SCI_GETSELECTIONEND m_ScintillaCommands[22]
	#define SCI_SETSELECTIONSTART m_ScintillaCommands[23]
	#define SCI_SETSELECTIONEND m_ScintillaCommands[24]
	#define SCI_GETCURLINE m_ScintillaCommands[25]
	#define SCI_LINEFROMPOSITION m_ScintillaCommands[26]
	#define SCI_LINELENGTH m_ScintillaCommands[27]
	#define SCI_GETTEXT m_ScintillaCommands[28]
	#define SCI_SETTEXT m_ScintillaCommands[29]
	#define SCI_GETLINE m_ScintillaCommands[30]
	#define SCI_GETLENGTH m_ScintillaCommands[31]
	#define SCI_SCROLLCARET m_ScintillaCommands[32]
	#define SCI_SETDOCPOINTER m_ScintillaCommands[33]
	#define SCI_SETCARETLINEBACK m_ScintillaCommands[34]
	#define SCI_SETCARETLINEVISIBLE m_ScintillaCommands[35]
	#define SCI_SETLINESTATE m_ScintillaCommands[36]
	#define SCI_GETLINESTATE m_ScintillaCommands[37]
	#define SCI_GOTOLINE m_ScintillaCommands[38]
	#define SCI_MARKERDEFINE m_ScintillaCommands[39]
	#define SCI_MARKERADD m_ScintillaCommands[40]
	#define SCI_MARKERDELETE m_ScintillaCommands[41]
	#define SCI_MARKERGET m_ScintillaCommands[42]
	#define SCI_MARKERSETBACK m_ScintillaCommands[43]
	#define SCI_CHARRIGHT m_ScintillaCommands[44]
	#define SCI_LINEUP m_ScintillaCommands[45]
	#define SCI_LINEDOWN m_ScintillaCommands[46]
	#define SCI_CALLTIPCANCEL m_ScintillaCommands[47]
	#define SCI_CALLTIPSETBACK m_ScintillaCommands[48]
	#define SCI_CALLTIPSETHLT m_ScintillaCommands[49]
	#define SCI_GOTOPOS m_ScintillaCommands[50]
	#define SCI_CANUNDO m_ScintillaCommands[51]
	#define SCI_CANREDO m_ScintillaCommands[52]
	#define SCI_GETANCHOR m_ScintillaCommands[53]
	#define SCI_CANPASTE m_ScintillaCommands[54]
	#define SCI_REPLACESEL m_ScintillaCommands[55]
	#define SCI_AUTOCACTIVE m_ScintillaCommands[56]
	#define SCI_AUTOCCANCEL m_ScintillaCommands[57]
	#define SCI_AUTOCSETCANCELATSTART m_ScintillaCommands[58]
	#define SCI_USEPOPUP m_ScintillaCommands[59]
	#define SCI_UNDO m_ScintillaCommands[60]
	#define SCI_REDO m_ScintillaCommands[61]
	#define SCI_CUT m_ScintillaCommands[62]
	#define SCI_COPY m_ScintillaCommands[63]
	#define SCI_PASTE m_ScintillaCommands[64]
	#define SCI_CLEAR m_ScintillaCommands[65]
	#define SCI_SELECTALL m_ScintillaCommands[66]
	#define SCI_EMPTYUNDOBUFFER m_ScintillaCommands[67]
	#define SCI_SEARCHANCHOR m_ScintillaCommands[68]
	#define SCI_SEARCHNEXT m_ScintillaCommands[69]
	#define SCI_STARTRECORD m_ScintillaCommands[70]
	#define SCI_STOPRECORD m_ScintillaCommands[71]
	#define SCI_AUTOCSETIGNORECASE m_ScintillaCommands[72]

#define snumnames 72



struct scidoc {
	void * docptr;
	int selstart;
	int selend;
};

struct NotifyHeader {
	// hwndFrom is really an environment specifc window handle or pointer
	// but most clients of Scintilla.h do not have this type visible.
	//WindowID hwndFrom;
	void *hwndFrom; 
	unsigned int idFrom;
	unsigned int code;
};

struct SCNotification {
	struct NotifyHeader nmhdr;
	int position;			// SCN_STYLENEEDED, SCN_MODIFIED
	int ch;					// SCN_CHARADDED, SCN_KEY
	int modifiers;			// SCN_KEY
	int modificationType;	// SCN_MODIFIED
	const char *text;		// SCN_MODIFIED
	int length;				// SCN_MODIFIED
	int linesAdded;			// SCN_MODIFIED
	int message;			// SCN_MACRORECORD
	unsigned long wParam;	// SCN_MACRORECORD
	int  lParam;			// SCN_MACRORECORD
	int line;				// SCN_MODIFIED
	int foldLevelNow;		// SCN_MODIFIED
	int foldLevelPrev;		// SCN_MODIFIED
	int margin;				// SCN_MARGINCLICK
	int listType;			// SCN_USERLISTSELECTION
};

	struct scintillastate{
		int curpos;
		int curline;
		int selstart;
		int selend;
		int canundo;
		int canredo;
		int anchor;
		int canpaste;
		bool havesel;
	};


/////////////////////////////////////////////////////////////////////////////
// CSciCtrl window


class CSciCtrl : public CWnd, public CMacroCommunicator
{
// Construction
public:
	CSciCtrl();
	~CSciCtrl();

//Operation
	void CreateSWindow();
	void Init();
	void GetBuffer(Cstr * s);
	void ClearAll();
	void ClearAllTlb();
	void OpenText(const char * name);
	void SetText(char * words);
	
	void LoadLuaFile(char * path);
	void doSaveScript();
	void doLoadScript();
	void doScriptSelection();

	void AddText(char * words);
	void AddLine(const char * line);
	char * GetWordBeg(int back,int * len);
	void ShowCallTip();
	void AutoCShow(int wantchars);
	int GetInfo(int code,char *params,int arg=NULL,int arg2=NULL);
	void ToSendMacroCommand(int cmd,int p1,char * t,char * params);
	void ToSendMessage(int cmd,const char * arg =NULL,const char * arg2=NULL);
	void SendText(const char * txt);
	void SendWithToolTip(const char * txt);
	void BeforePlay();
	void AfterPlay();
	void StartStopRecord(int start);
	bool HandleNotification(LPARAM lParam);
	void SendToDoc(int docnum);
	void GetState();
	void HandleMenu(int rep);
	void SetLexer(int lexer);
	//Debugging
	bool FilerxDebug(macro * m,int line);
	bool ShowExpr(macro * m ,int * cpos);
	// Misc
	int  GetCurPos() {return SendMessage(SCI_GETCURRENTPOS,0,0);}

// Attributes
public:
	int * m_ScintillaCommands;		// array of used Scintilla Command codes
	char * m_keywords;				// list of space separated keywords
	int curdocnum;
	scidoc doc[4];
	Cstr scd_opened;				//path of last file internally opened by SCD_OPEN
	scintillastate state;
	int auto_autocomplete;
	int auto_insertclosing;
	char luacurrentscript[MAX_PATH];

	// Generated message map functions
protected:
	//{{AFX_MSG(CSciCtrl)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCICTRL_H__23720648_3734_11D5_9469_A8CCCCD6F97D__INCLUDED_)
