#if !defined(AFX_proptreeCTRL_H__INCLUDED_)
#define AFX_proptreeCTRL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// proptreeCtrl.h : header file
//

#define GROUP_MAX 6
#define GROUP_FILERX GROUP_MAX


/////////////////////////////////////////////////////////////////////////////
// CproptreeCtrl window

class CPropTreeCtrl : public CFilerTree
{
// Construction
public:
	CPropTreeCtrl();
	~CPropTreeCtrl();

// Attributes
public:

	HTREEITEM hprops[7];
// Operations
public:
	void InitTree();

	void AddProperty(char * p);

	HTREEITEM InsertKey(const char * name,HTREEITEM parent,HTREEITEM after=TVI_SORT);
	void IniToTree();
	HTREEITEM InsertSection(const char * name,HTREEITEM parent);
	void ReloadIni();
	void DropItemFromList ();
	bool isMacroBar(HTREEITEM h) { return GetItemText(h)=="macrobar";};
	bool mayDrag(HTREEITEM h) {return isMacroBar(GetParentItem(h));};
	bool mayDropAfter(HTREEITEM h)  {return isMacroBar(GetParentItem(h));};
	bool mayDropInto(HTREEITEM h) {return isMacroBar(h);};
	void doDropItem();
	void doOnEndlabeledit(HTREEITEM selitem,char * newtext);

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_proptreeCTRL_H__INCLUDED_)
