#if !defined(MACCORE_H__INCLUDED_)
#define MACCORE_H__INCLUDED_



#define MAC_VOID 65533
#define MAC_EMPTY 65534
#define MAC_COMMENT 65535

#define MAC_CALL 1
#define MAC_DUMP 2

#define MAC_INT 100
#define MAC_INTAFFECT 101		//must be MAC_INT+1
#define MAC_AFFECTINT 102		//must be MAC_INT+2
#define MAC_STRING 103
#define MAC_STRINGAFFECT 104	//must be MAC_STRING+1
#define MAC_AFFECTSTRING 105	//must be MAC_STRING+2
#define MAC_AFFECTEXPR 106
#define MAC_MESSAGE 107
#define MAC_INCR 108
#define MAC_DECR 109
#define MAC_BLOCKBEG 110
#define MAC_BLOCKEND 111
#define MAC_WHILE 112
#define MAC_WHILEND 113
#define MAC_DO 114
#define MAC_IF 115
#define MAC_ELSE 116
#define MAC_RETURN 117
#define MAC_FOR 118
#define MAC_FOR2 119
#define MAC_JUMP 120
#define MAC_NOP 121
#define MAC_BREAK 122
#define MAC_CONTINUE 123
#define MAC_EXECUTE 124
#define MAC_WAIT 125
#define MAC_ERROR 126
#define MAC_WARNING 127
#define MAC_AFFECTCHAR 129
#define MAC_INTARRAY 130
#define MAC_AFFECTINTARRAY 131
#define MAC_STRINGARRAY 132
#define MAC_AFFECTSTRINGARRAY 133
#define MAC_SETCURDIR 134
#define MAC_SHELLEXECUTE 135
#define MAC_SHELLEXECUTEEX 136
#define MAC_SCRIPTBEG 137
#define MAC_SCRIPTLINE 138
#define MAC_SCRIPTEND 139
#define MAC_SETINPUTSEPARATOR 140
#define MAC_SORT 141
#define MAC_CREATEDIR 142
#define MAC_COPYFILE 143
#define MAC_MOVEFILE 144
#define MAC_SAVESTRINGAS 145
#endif //MACCORE_H__INCLUDED_
