#if !defined(AFX_FILELISTCTRL_H__INCLUDED_)
#define AFX_FILELISTCTRL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FileListCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFileListCtrl window

class CFileTreeCtrl;
//class CToolDlg;

class CFileListCtrl : public CListCtrl
{
// Construction
public:
	CFileListCtrl();
	~CFileListCtrl();

// Attributes
public:
	int curfilternum;
	Cstr curfilterlist;
// Multiselection iteration
	POSITION SelectedPos;
// Drag'n Drop
	CImageList* m_pDragImage;
	BOOL		m_bDragging;
	int			m_nDragIndex;
	HTREEITEM	m_hDropItem;


// Operations
public:
	void DeleteAllItems();				//frees list
	void DisplayList(TreeNode * pItem);	//Shows pItem Child files
	void GetFirstSelectedPath(char * p);			//when double-clicked
	void GetNextSelectedPath(char * p);		
	void SelectFile(char * name);		//Finds a file in list
	void OnContextMenu(CPoint point);
	bool InFilter(const char * s);


	// Generated message map functions
protected:
	//{{AFX_MSG(CFileListCtrl)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILELISTCTRL_H__INCLUDED_)
