// FileTreeCtrl.h: interface for the CFileTreeCtrl class.

#if !defined(AFX_FILETREECTRL_H__INCLUDED_)
#define AFX_FILETREECTRL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CFileTreeCtrl window

class CFileTreeCtrl : public CFilerTree
{
// Construction
public:
	CFileTreeCtrl();
	~CFileTreeCtrl();

// Operations
public:
	void DisplayTree();					//Builds and explores Root
	void Explore(HTREEITEM hParent);	//Finds Files and subfolders
	HTREEITEM	FindItem(const char*);	//Finds Item corresponding to path
	void GetSelectedNodePath(char * path);
	void Refresh(const char * pth);

	void cleanOneItemData(UINT pData);
	void doOnSelchanged(HTREEITEM olditem,HTREEITEM newitem) ;
	void doOnExpand(HTREEITEM hItem); 
// Attributes
public:
	TreeNode * m_pRoot;					//points to root item
	TreeNode * selNode;					//last selected node
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILETREECTRL_H__INCLUDED_)
