#if !defined(AFX_tlbtreeCTRL_H__INCLUDED_)
#define AFX_tlbtreeCTRL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// proptreeCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTlbTreeCtrl window




#include "afxcoll.h"
#include "afxtempl.h"



struct CTypeLibraryData {
	CString m_strCLSIDTypeLib;
	Cstr m_strDescription;
	char * m_path;
	long m_lMajorVersion;
	long m_lMinorVersion;
	int index;
	bool visited;
	int type;
};


//class CFilerDlg;
class CTlbTreeCtrl : public CFilerTree
{
// Construction
public:
	CTlbTreeCtrl();
	~CTlbTreeCtrl();

// Attributes
public:
	//CFilerDlg * dlg;			//parent dialog
	HTREEITEM hReg;
	HTREEITEM hRegFav;
	HTREEITEM hFiles;
	HTREEITEM groupfolderitem[8];

	ITypeLib* m_pTypeLib;
	ITypeInfo* m_pCurrentTypeInfo;
	CTypeLibraryData * tmpdata;

// Operations
public:
	void InitTree();
	HTREEITEM MyInsertItem(const char * text,int typ,HTREEITEM parent,int iter=-1,bool withdummy=false);
	void cleanOneItemData(UINT pData);
	int GetItemType(HTREEITEM h) ;

	void AddTypeLibFile(const char * path);
	bool LoadTypeLibFromFile(const char * path,ITypeLib ** tlb);
	BOOL EnumerateRegistryForTypeLibEntries();
	void GetProgID(HTREEITEM item,const char * ID);
	BOOL GetInformationForTLB(HTREEITEM item,bool dovisit);
	char * GetTlbPath(HKEY key);
	BOOL  ExtractComponentsFromTLB(HTREEITEM item,bool dovisit);
	BOOL GetTypeInfoInformation(HTREEITEM item,bool dovisit);
	BOOL GetTypeAttributes(HTREEITEM item,bool dovisit);
	void GetValue(VARIANT * v,Cstr * retstr)	;
	void GetType(TYPEDESC * pTypeDesc,Cstr * s);
	void GetParameters(FUNCDESC* pFuncDesc,Cstr * rets);

	void GetMoreInfo(HTREEITEM item,int typ, bool visit);
	void doOnExpand(HTREEITEM hItem) ;
	void doOnSelchanged(HTREEITEM itemold, HTREEITEM itemnew) ;
	void doOnDblclk(HTREEITEM hItem);

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_tlbtreeCTRL_H__INCLUDED_)
