

// Director  <--> SciTE
#define SCD_IDENTIFY 6100
#define SCD_CLOSING 6101

// From Director to SciTE
#define SCD_ASKFILENAME 6200
#define SCD_ENUMPROPERTIES 6201
#define SCD_SETPROPERTY 6202
#define SCD_MACROENABLE 6203
#define SCD_CURRENTMACRO 6204
#define SCD_MACROLIST 6205
#define SCD_MACROCOMMAND 6206
#define SCD_ASKPROPERTY 6207
//also macro instructions
#define SCD_OPEN 6300
#define SCD_FIND 6301
#define SCD_REPLACEALL 6302
#define SCD_CLOSE 6303
#define SCD_QUIT 6304
#define SCD_SAVEAS 6305
#define SCD_EXPORTASHTML 6306
#define SCD_EXPORTASPDF 6307
#define SCD_EXPORTASRTF 6308
#define SCD_MENUCOMMAND 6309
#define SCD_OUTPUT 6310
#define SCD_OUTPUTSIZE 6311
#define SCD_MENUCOMMANDW 6312
#define SCD_MINIMIZE 6313
#define SCD_RESTORE 6314
#define SCD_LOADSCRIPT 6315
#define SCD_EXTENDER 6316
#define SCD_CWD 6317
#define SCD_EXPORTASLATEX 6318 
#define SCD_EXPORTASXML 6319
#define SCD_GOTO 6320
#define SCD_INSERT 6321
#define SCD_LOADSESSION 6322 


// From SciTE to Director
#define SCD_OPENED 6400
#define SCD_SAVED 6401
#define SCD_SWITCHED 6402
#define SCD_PROPERTY 6403
#define SCD_MACRO 6404
#define SCD_MACRO_RUN 6405
#define SCD_MACRO_GETLIST 6406
#define SCD_MACRO_RECORD 6407
#define SCD_MACRO_STOPRECORD 6408
#define SCD_FILENAME 6409
#define SCD_MACRO_INTINFO 6410
#define SCD_MACRO_STRINGINFO 6411

// From macro to Filerx
#define FLX_MESSAGES 6500
#define FLX_GETROOTITEM 6500
#define FLX_GETCHILDITEM 6501
#define FLX_GETNEXTSIBLINGITEM 6502
#define FLX_GETPARENTITEM 6503
#define FLX_GETSELECTEDITEM 6504
#define FLX_GETITEMTEXT 6510
#define FLX_GETITEMPATH 6511
#define FLX_GETITEMTYPE 6512
#define FLX_FINDITEM 6513
#define FLX_FINDITEMPREPARE 6514

#define FLX_GETLISTCOUNT 6520
#define FLX_GETLISTITEMTEXT 6521
#define FLX_GETLISTITEMPATH 6521

#define FLX_GETIMISCINFO 6530
#define FLX_GETSMISCINFO 6531
#define FLX_SCRIPTEVAL 6532

#define FLX_EXPANDITEM 6540
#define FLX_COLLAPSEITEM 6541
#define FLX_SELECTITEM 6542
#define FLX_SORTCHILDREN 6543
#define FLX_WINDOWSIZE 6544
#define FLX_WINDOWPOS 6545
#define FLX_WINDOWARRANGE 6546
#define FLX_SHOWTREE 6547
#define FLX_SHOWTAB2 6548
#define FLX_STATUS 6549
#define FLX_SCRIPTINIT 6550
#define FLX_SCRIPTEXIT 6551
#define FLX_SCRIPTADDCODE 6552
#define FLX_SCRIPTEXECUTE 6553
#define FLX_VIEWMACROBAR 6554
#define FLX_SPLASH 6555



#define TYPE_ROOT 1
#define TYPE_PROJECT 2
#define TYPE_FOLDER 4
#define TYPE_FILE 8

#define TYPE_MACROFILE 2
#define TYPE_MACRO 4

// Filerx.ini sections
#define SECTION_MAX 13
#define SECTION_WINDOW 0
#define SECTION_WORK 1
#define SECTION_FILTERS 2
#define SECTION_PROJECTS 3
#define SECTION_MACROS 4
#define SECTION_FILELISTMENU 5
#define SECTION_FILETREEMENU 6
#define SECTION_PROJECTMENU 7
#define SECTION_TLBMENU 8
#define SECTION_TLBFAVORITES 9
#define SECTION_SHORTCUTS 10
#define SECTION_MACROBAR 11
#define SECTION_MACROBARMENU 12
#define SECTION_SCINTILLAMENU 13



